//----------------------------------------------------------------------------
// marsCap.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: marsCap.pas
//----------------------------------------------------------------------------
#ifndef marsCapHPP
#define marsCapHPP
//----------------------------------------------------------------------------
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Marscap
{
//-- type declarations -------------------------------------------------------
enum TMarsCaptionSystemButtonKind { sbClose, sbMinimize, sbMaximize, sbHelp };

class __declspec(delphiclass) TMarsCaptionSystemButton;
class __declspec(pascalimplementation) TMarsCaptionSystemButton : public Buttons::TSpeedButton
{
	typedef Buttons::TSpeedButton inherited;
	
private:
	Forms::TForm* FParentForm;
	bool FDown;
	bool FDragging;
	TMarsCaptionSystemButtonKind FKind;
	int FDLeft;
	int FDTop;
	int FDWidth;
	int FDHeight;
	void __fastcall SetKind(TMarsCaptionSystemButtonKind Value);
	void __fastcall SetDLeft(int Value);
	void __fastcall SetDTop(int Value);
	void __fastcall SetDWidth(int Value);
	void __fastcall SetDHeight(int Value);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall SystemButtonClick(System::TObject* Sender);
	
public:
	__fastcall virtual TMarsCaptionSystemButton(Classes::TComponent* AOwner);
	void __fastcall Draw(HDC DC);
	__property TMarsCaptionSystemButtonKind Kind = {read=FKind, write=SetKind, nodefault};
	__property int DLeft = {read=FDLeft, write=SetDLeft, nodefault};
	__property int DTop = {read=FDTop, write=SetDTop, nodefault};
	__property int DWidth = {read=FDWidth, write=SetDWidth, nodefault};
	__property int DHeight = {read=FDHeight, write=SetDHeight, nodefault};
public:
	/* TSpeedButton.Destroy */ __fastcall virtual ~TMarsCaptionSystemButton(void) { }
	
};

class __declspec(delphiclass) TMarsCaption;
class __declspec(pascalimplementation) TMarsCaption : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	long FOldStyle;
	Forms::TBorderIcons FParentIcons;
	Forms::TForm* FParentForm;
	int FParentHandle;
	void *FOldWindowProc;
	void *FNewWindowProc;
	Graphics::TColor FActiveBeginColor;
	Graphics::TColor FActiveEndColor;
	Graphics::TColor FInactiveBeginColor;
	Graphics::TColor FInactiveEndColor;
	Graphics::TColor FActiveFontColor;
	Graphics::TColor FInactiveFontColor;
	System::AnsiString FApplicationName;
	Graphics::TFont* FApplicationNameFont;
	Graphics::TFont* FCaptionFont;
	bool FAutoSize;
	int FNumColors;
	TMarsCaptionSystemButton* FCloseButton;
	TMarsCaptionSystemButton* FMinimizeButton;
	TMarsCaptionSystemButton* FMaximizeButton;
	TMarsCaptionSystemButton* FHelpButton;
	Windows::TRect FCaptionRect;
	Windows::TRect FMenuIconRect;
	Windows::TRect FSystemButtonsRect;
	Windows::TRect FTextRect;
	TFormBorderStyle FParentBorderStyle;
	Forms::TBorderIcons FSystemButtons;
	int FBorderHeight;
	int FBorderWidth;
	int FCaptionHeight;
	bool FRButtonCaptionDown;
	int FLButtonMenuDownTick;
	bool FLButtonIconicCaptionDown;
	bool FIconicWindowMove;
	tagPOINT FLButtonIconicCaptionDownPos;
	Windows::TRect FLButtonIconicCaptionDownRect;
	tagPOINT FLastPos;
	void __fastcall WMNCActivate(Messages::TWMNCActivate &Msg);
	void __fastcall WMActivate(Messages::TWMActivate &Msg);
	void __fastcall WMNCMouseMessages(Messages::TMessage &Msg);
	void __fastcall WMNCPaint(Messages::TMessage &Msg);
	void __fastcall WMDestroy(Messages::TMessage &Msg);
	void __fastcall WMCommand(Messages::TMessage &Msg);
	void __fastcall WMLButtonUp(Messages::TWMMouse &Msg);
	void __fastcall WMMouseMove(Messages::TWMMouse &Msg);
	void __fastcall CallOldWindowProc(Messages::TMessage &Msg);
	void __fastcall MarsCaptionWindowProc(Messages::TMessage &Msg);
	void __fastcall MarsGetMenu(HMENU &M);
	bool __fastcall WindowIsActive(void);
	void __fastcall PaintBackGround(HDC DC, bool Active);
	void __fastcall PaintMenuIcon(HDC DC);
	void __fastcall PaintTitle(HDC DC, bool Active);
	void __fastcall Paint(bool Active);
	void __fastcall SetActiveBeginColor(Graphics::TColor Value);
	void __fastcall SetActiveEndColor(Graphics::TColor Value);
	void __fastcall SetInactiveBeginColor(Graphics::TColor Value);
	void __fastcall SetInactiveEndColor(Graphics::TColor Value);
	void __fastcall SetActiveFontColor(Graphics::TColor Value);
	void __fastcall SetInactiveFontColor(Graphics::TColor Value);
	void __fastcall SetApplicationName( System::AnsiString Value);
	void __fastcall SetApplicationNameFont(Graphics::TFont* Value);
	void __fastcall SetCaptionFont(Graphics::TFont* Value);
	void __fastcall SetAutoSize(bool Value);
	void __fastcall SetNumColors(int Value);
	void __fastcall RestoreSysmenuStyle(void);
	void __fastcall DeleteSysmenuStyle(void);
	void __fastcall CalculateCaption(void);
	
protected:
	void __fastcall HookWindowProc(void);
	void __fastcall UnHookWindowProc(void);
	virtual void __fastcall Loaded(void);
	__property void * OldWindowProc = {read=FOldWindowProc, nodefault};
	__property void * NewWindowProc = {read=FNewWindowProc, nodefault};
	
public:
	__fastcall virtual TMarsCaption(Classes::TComponent* AOwner);
	__fastcall virtual ~TMarsCaption(void);
	void __fastcall Repaint(void);
	
__published:
	__property Graphics::TColor ActiveBeginColor = {read=FActiveBeginColor, write=SetActiveBeginColor, 
		nodefault};
	__property Graphics::TColor ActiveEndColor = {read=FActiveEndColor, write=SetActiveEndColor, nodefault
		};
	__property Graphics::TColor ActiveFontColor = {read=FActiveFontColor, write=SetActiveFontColor, nodefault
		};
	__property Graphics::TColor InactiveBeginColor = {read=FInactiveBeginColor, write=SetInactiveBeginColor
		, nodefault};
	__property Graphics::TColor InactiveEndColor = {read=FInactiveEndColor, write=SetInactiveEndColor, 
		nodefault};
	__property Graphics::TColor InactiveFontColor = {read=FInactiveFontColor, write=SetInactiveFontColor
		, nodefault};
	__property System::AnsiString ApplicationName = {read=FApplicationName, write=SetApplicationName, nodefault
		};
	__property Graphics::TFont* ApplicationNameFont = {read=FApplicationNameFont, write=SetApplicationNameFont
		, nodefault};
	__property Graphics::TFont* CaptionFont = {read=FCaptionFont, write=SetCaptionFont, nodefault};
	__property int NumColors = {read=FNumColors, write=SetNumColors, nodefault};
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class Forms::TBorderIcons ;

}	/* namespace Marscap */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Marscap;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// marsCap
